package com.canvassoft.Player;

import java.lang.String;
import java.util.List;
import java.util.ArrayList;
import java.util.Random;

import org.aiwolf.client.base.player.AbstractRole;
import org.aiwolf.client.base.player.AbstractSeer;
import org.aiwolf.client.base.player.AbstractVillager;
import org.aiwolf.client.lib.TemplateTalkFactory;
import org.aiwolf.client.lib.TemplateWhisperFactory;
import org.aiwolf.client.lib.Topic;
import org.aiwolf.client.lib.Utterance;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Judge;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.data.Talk;

import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

import com.canvassoft.Lib.*;

public class CanvasMediumPlayer extends AbstractVillager
{
	private Brain brain;
	
	boolean init;
	boolean coMedium;
	
	public CanvasMediumPlayer(Brain _brain)
	{
		brain = _brain;
		init = false;
		coMedium = false;
	}

	@Override
	public void dayStart()
	{
		if (!init)
		{
			brain.init(getLatestDayGameInfo(), getGameSetting());
			init = true;
		}
		else
		{
			brain.dayStart(getLatestDayGameInfo());
		}
	}
	

	@Override
	public void update(GameInfo gameInfo)
	{
		super.update(gameInfo);
		brain.update(getLatestDayGameInfo());
	}

	@Override
	public String talk()
	{
		String talk_string = "";
		
		if (!coMedium)
		{
			coMedium = true;
			talk_string = TemplateTalkFactory.comingout(getMe(), Role.MEDIUM);
		}
		else
		{
			talk_string = brain.getTalkMediumResult();
			if (talk_string == "")
			{
				talk_string = brain.createTalkEstimate();				
			}
		}
		
		if (talk_string == "")
		{
			return Talk.OVER;
		}
		else
		{
			return talk_string;
		}
	}
	
	@Override
	public Agent vote()
	{
		ArrayList<Agent> voteCandidates = new ArrayList<Agent>();
		voteCandidates.addAll(getLatestDayGameInfo().getAliveAgentList());
		voteCandidates.remove(getMe());
		if (voteCandidates.size() == 0)return null;
		return brain.getVoteAgent(voteCandidates);
	}

	private Agent randomSelect(ArrayList<Agent> agentList)
	{
		if (agentList.size()==0)return null;
		int num = new Random().nextInt(agentList.size());
		return agentList.get(num);
	}


	@Override
	public void finish() {
		// TODO Auto-generated method stub

	}
}
