package com.canvassoft.Player;

import java.lang.String;
import java.util.List;
import java.util.ArrayList;
import java.util.Random;

import org.aiwolf.client.base.player.AbstractPossessed;
import org.aiwolf.client.base.player.AbstractRole;
import org.aiwolf.client.base.player.AbstractSeer;
import org.aiwolf.client.base.player.AbstractVillager;
import org.aiwolf.client.lib.TemplateTalkFactory;
import org.aiwolf.client.lib.TemplateWhisperFactory;
import org.aiwolf.client.lib.Topic;
import org.aiwolf.client.lib.Utterance;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Judge;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.data.Talk;

import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

import com.canvassoft.Lib.*;

public class CanvasPassessedPlayer extends AbstractPossessed
{
	boolean isComingOut = false;
	private Brain brain;
	
	boolean coSeer = false;
	boolean init = false;
	boolean talkSeeredAgent = false;
	
	List<Judge> seeredJudges = new ArrayList<Judge>();
	List<Agent> seeredAgents = new ArrayList<Agent>();
			
	public CanvasPassessedPlayer(Brain _brain)
	{
		brain = _brain;
		
	}

	@Override
	public void dayStart()
	{
		if (!init)
		{
			brain.init(getLatestDayGameInfo(), getGameSetting());
			init = true;
		}
		else
		{
			brain.dayStart(getLatestDayGameInfo());
			talkSeeredAgent = false;
			
			ArrayList<Agent> divineCandidates = new ArrayList<Agent>();

			divineCandidates.addAll(getLatestDayGameInfo().getAliveAgentList());
			
			divineCandidates.remove(getMe());
			for(Judge judge: seeredJudges)
			{
				if (divineCandidates.contains(judge.getTarget())){
					divineCandidates.remove(judge.getTarget());
				}
			}
			
			Agent seer_agent = null;
			if (divineCandidates.size() > 0)
			{
				seer_agent = brain.getSeerAgent(divineCandidates);
				if (seer_agent == null)
				{
					seer_agent = brain.randamAgent(divineCandidates);
				}
			}
			
			if (seer_agent != null)
			{
				Species result = divineCandidates.size()<=2 ? Species.WEREWOLF : Species.HUMAN;
				
				Judge judge = new Judge(getLatestDayGameInfo().getDay(), getMe(), seer_agent, result);
				seeredJudges.add(judge);
			}
		}
	}
	

	@Override
	public void update(GameInfo gameInfo)
	{
		super.update(gameInfo);
		brain.update(getLatestDayGameInfo());
	}


	@Override
	public String talk()
	{
		String talk_string = "";
		
		if (!coSeer)
		{
			coSeer = true;
			talk_string = TemplateTalkFactory.comingout(getMe(), Role.SEER);
		}
		else
		{
			int index = seeredJudges.size()-1;
			if (index >= 0 && !talkSeeredAgent)
			{
				talkSeeredAgent = true;
				Judge judge = seeredJudges.get(seeredJudges.size()-1);
				talk_string = TemplateTalkFactory.divined(judge.getTarget(), judge.getResult());
			}
			if (talk_string == "")
			{
				talk_string = brain.createTalkPossessedEstimate();				
			}
		}
		
		if (talk_string == "")
		{
			return Talk.OVER;
		}
		else
		{
			return talk_string;
		}
	}
	
	@Override
	public Agent vote()
	{
		ArrayList<Agent> whiteAgent = new ArrayList<Agent>();
		ArrayList<Agent> blackAgent = new ArrayList<Agent>();

		for (Judge judge: seeredJudges)
		{
			if (getLatestDayGameInfo().getAliveAgentList().contains(judge.getTarget()))
			{
				switch(judge.getResult())
				{
				case HUMAN:
					whiteAgent.add(judge.getTarget());
					break;
					
				case WEREWOLF:
					blackAgent.add(judge.getTarget());
					break;
				}
			}
		}
		
		if (blackAgent.size() > 0)
		{
			return randomSelect(blackAgent);
		}
		else
		{
			ArrayList<Agent> voteCandidates = new ArrayList<Agent>();
			voteCandidates.addAll(getLatestDayGameInfo().getAliveAgentList());
			voteCandidates.remove(getMe());
			voteCandidates.removeAll(whiteAgent);

			if (voteCandidates.size() > 1)
			{
				return brain.getVoteAgent(voteCandidates);
			}
			else
			{
				return null;
			}
		}
	}

	private Agent randomSelect(ArrayList<Agent> agentList)
	{
		if (agentList.size() == 0)return null;
		int num = new Random().nextInt(agentList.size());
		return agentList.get(num);
	}


	@Override
	public void finish() {
		// TODO Auto-generated method stub

	}
}
