package com.canvassoft.Player;

import java.lang.String;
import java.util.List;
import java.util.ArrayList;
import java.util.Random;

import org.aiwolf.client.base.player.AbstractRole;
import org.aiwolf.client.base.player.AbstractSeer;
import org.aiwolf.client.lib.TemplateTalkFactory;
import org.aiwolf.client.lib.TemplateWhisperFactory;
import org.aiwolf.client.lib.Topic;
import org.aiwolf.client.lib.Utterance;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Judge;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.data.Talk;

import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

import com.canvassoft.Lib.*;

public class CanvasSeerPlayer extends AbstractSeer
{
	boolean isComingOut = false;
	private Brain brain;
	
	boolean coSeer = false;
	boolean init = false;
		
	public CanvasSeerPlayer(Brain _brain)
	{
		brain = _brain;	
	}

	@Override
	public void dayStart()
	{
		if (!init)
		{
			brain.init(getLatestDayGameInfo(), getGameSetting());
			init = true;
		}
		else
		{
			brain.dayStart(getLatestDayGameInfo());
		}
	}
	
	@Override
	public void update(GameInfo gameInfo)
	{
		super.update(gameInfo);
		brain.update(getLatestDayGameInfo());
	}
	
	@Override
	public String talk()
	{
		String talk_string = "";
		
		if (!coSeer)
		{
			coSeer = true;
			talk_string = TemplateTalkFactory.comingout(getMe(), Role.SEER);
		}
		else
		{
			talk_string = brain.getTalkSeerResult();
			if (talk_string == "")
			{
				talk_string = brain.createTalkEstimate();				
			}
		}
		
		if (talk_string == "")
		{
			return Talk.OVER;
		}
		else
		{
			return talk_string;
		}
	}
	
	@Override
	public Agent vote()
	{
		ArrayList<Agent> whiteAgent = new ArrayList<Agent>();
		ArrayList<Agent> blackAgent = new ArrayList<Agent>();

		for (Judge judge: getMyJudgeList())
		{
			if (getLatestDayGameInfo().getAliveAgentList().contains(judge.getTarget()))
			{
				switch(judge.getResult())
				{
				case HUMAN:
					whiteAgent.add(judge.getTarget());
					break;
					
				case WEREWOLF:
					blackAgent.add(judge.getTarget());
					break;
				}
			}
		}
		
		if (blackAgent.size() > 0)
		{
			return randomSelect(blackAgent);
		}
		else
		{
			ArrayList<Agent> voteCandidates = new ArrayList<Agent>();
			voteCandidates.addAll(getLatestDayGameInfo().getAliveAgentList());
			voteCandidates.remove(getMe());
			voteCandidates.removeAll(whiteAgent);

			if (voteCandidates.size() == 0)return null;
			
			return brain.getVoteAgent(voteCandidates);
		}
	}

	private Agent randomSelect(ArrayList<Agent> agentList)
	{
		int num = new Random().nextInt(agentList.size());
		return agentList.get(num);
	}

	@Override
	public Agent divine() {
		ArrayList<Agent> divineCandidates = new ArrayList<Agent>();
		divineCandidates.addAll(getLatestDayGameInfo().getAliveAgentList());
		
		divineCandidates.remove(getMe());
		for(Judge judge: getMyJudgeList())
		{
			if (divineCandidates.contains(judge.getTarget())){
				divineCandidates.remove(judge.getTarget());
			}
		}
		
		if (divineCandidates.size() > 0)
		{
			return brain.getSeerAgent(divineCandidates);
		}
		else
		{
			return getMe();
		}		
	}

	@Override
	public void finish() {
		// TODO Auto-generated method stub

	}
}
