package com.canvassoft.Player;

import java.lang.String;
import java.util.List;
import java.util.Map;
import java.util.ArrayList;
import java.util.Random;

import org.aiwolf.client.base.player.AbstractRole;
import org.aiwolf.client.base.player.AbstractSeer;
import org.aiwolf.client.base.player.AbstractVillager;
import org.aiwolf.client.base.player.AbstractWerewolf;
import org.aiwolf.client.lib.TemplateTalkFactory;
import org.aiwolf.client.lib.TemplateWhisperFactory;
import org.aiwolf.client.lib.Topic;
import org.aiwolf.client.lib.Utterance;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Judge;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.data.Talk;

import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

import com.canvassoft.Lib.*;

public class CanvasWolfPlayer extends AbstractWerewolf
{
	boolean isComingOut = false;
	private Brain brain;
	
	boolean init = false;
	
	public Agent otherWolf;
	public Agent possessed;
	public Agent attackedAgent;
	public Agent guardSuccessAgent;
		
	public CanvasWolfPlayer(Brain _brain)
	{
		brain = _brain;
	}

	@Override
	public void dayStart()
	{
		if (!init)
		{
			brain.init(getLatestDayGameInfo(), getGameSetting());
			
			for (Agent agent : getWolfList())
			{
				if (agent != brain.advanceGameInfo.self)
				{
					otherWolf = agent;
				}
			}
			Debug.Log("OtherWolf : "+otherWolf.getAgentIdx());
			
			init = true;
		}
		else
		{
			brain.dayStart(getLatestDayGameInfo());
			
			guardSuccessAgent = null;
			Agent attacked_agent = getLatestDayGameInfo().getAttackedAgent();
			if (attacked_agent != null)
			{
				Debug.Log("attacked_agent : "+attacked_agent.toString());				
			}
			else
			{
				guardSuccessAgent = attacked_agent;
			}
		}
	}
	

	@Override
	public void update(GameInfo gameInfo)
	{
		super.update(gameInfo);
		brain.update(getLatestDayGameInfo());
		
		searchPassessed();
	}
	
	private void searchPassessed()
	{
		if (possessed != null)return;
		
		for (int src=0; src<brain.advanceGameInfo.playerCount; src++)
		{
			for (int dest=0; dest<brain.advanceGameInfo.playerCount; dest++)
			{
				if (dest == brain.advanceGameInfo.selfIndex || dest == otherWolf.getAgentIdx())
				{
					if (brain.advanceGameInfo.seerResultInfos[src][dest][Define.Villager] == 1)
					{
						possessed = brain.advanceGameInfo.indexToAgent(src);
						return;
					}
					
					if (brain.advanceGameInfo.mediumResultInfos[src][dest][Define.Villager] == 1)
					{
						possessed = brain.advanceGameInfo.indexToAgent(src);
						return;
					}
				}
				else if (brain.advanceGameInfo.seerResultInfos[src][dest][Define.WereWolf] == 1)
				{
					possessed = brain.advanceGameInfo.indexToAgent(src);
					return;
				}
				else if (brain.advanceGameInfo.mediumResultInfos[src][dest][Define.WereWolf] == 1)
				{
					possessed = brain.advanceGameInfo.indexToAgent(src);
					return;
				}
			}
		}
	}

	@Override
	public String talk()
	{
		String talk_string = brain.createTalkEstimate();
		if (talk_string == "")
		{
			talk_string = brain.createTalkVote();
			if (talk_string == "")
			{
				return Talk.OVER;
			}
		}
		
		return talk_string;
	}

	@Override
	public String whisper()
	{
		return Talk.OVER;
	}
	
	@Override
	public Agent attack()
	{
		ArrayList<Agent> voteCandidates = new ArrayList<Agent>();
		
		voteCandidates.addAll(getLatestDayGameInfo().getAliveAgentList());
		voteCandidates.remove(getMe());
		if (voteCandidates.contains(otherWolf))
		{
			voteCandidates.remove(otherWolf);
		}
		
		Agent attack_agent = brain.getMostWhiteAgent(voteCandidates, false);
		if (attack_agent != null)
		{
			if (attackedAgent == attack_agent && attackedAgent == guardSuccessAgent)
			{
				attack_agent = null;
			}
		}
		
		if (attack_agent == null)
		{
			if (voteCandidates.size() > 1 && possessed != null)
			{
				voteCandidates.remove(possessed);
			}
			attack_agent = brain.randamAgent(voteCandidates);
		}
		
		attackedAgent = attack_agent;
		return attack_agent;
	}
	
	@Override
	public Agent vote()
	{
		ArrayList<Agent> voteCandidates = new ArrayList<Agent>();
		voteCandidates.addAll(getLatestDayGameInfo().getAliveAgentList());
		voteCandidates.remove(getMe());
		Agent vote_agent = brain.getMostBlackAgent(voteCandidates, false);
		if (vote_agent == null)
		{
			if (voteCandidates.size() > 1 && voteCandidates.contains(otherWolf))
			{
				voteCandidates.remove(otherWolf);
			}
			
			if (voteCandidates.size() > 1 && possessed != null)
			{
				voteCandidates.remove(possessed);
			}
			vote_agent = brain.randamAgent(voteCandidates);
		}
		
		return vote_agent;
	}

	private Agent randomSelect(ArrayList<Agent> agentList)
	{
		int num = new Random().nextInt(agentList.size());
		return agentList.get(num);
	}


	@Override
	public void finish() {
		// TODO Auto-generated method stub

	}
}
